from IPython import get_ipython


class PhoenixHelp:

    def pm(self, x):
        if self.silent == False:
            print(x)

        # endif

    def help(self):

        self.__on_help = """HelpPhoenix
        HELP ON BEC

        General online documentation of BEC
        https://beamline-experiment-control.readthedocs.io/en/latest/

        code in git
        https://gitlab.psi.ch/bec

        For help on BL specific topics see

        phoenix.help()
        phoenix.help_phoenix()  ... etc...

        find attributes using tab extension on command line

        BL related MAGIC COMMANDS on iphython shell start with ph:
        Example:
        %ph_create_base_config
        .. etc .. find all commands by tab extension, description in phoenix.help_magic


        """
        self.pm(self.__on_help)
        # self.pm(self.on_attributes)

    def help_phoenix_file_structure(self):
        self.__on_phoenix_file_structure = """


        phoenix_bec/scripts     -- directory for general BL scripts
                                            (auto read to server)
        ....... phoenix.py      -- base classes for BL
        ....... phoenix_help.py -- contains classes for help as relevant
                                        for BEC @ PHOENIX operation

        phoenix_bec/scans       -- location of dedicated scan types

        phoenix_bec/bec_iphython_client  -- directory for startup files
        ....... post_startup.py          -- BL specific definitions, read when bec starts
                                            Definiton of BL related magic commands

        phoenix_bec/devcices            -- Location for specific devices
        phoenix_bec/device_configs      -- location of yaml configuration files

        phoenix_bec/local_scripts       -- space for local and test script
                                            (NOT auto read to server)


        #######################################################################

        IT IS ABSOLUTELY FORBIDDEN FOR USERS TO MAKE ANY CHANGES TO ANY OF THE FILES

        #######################################################################



        """

    def help_phoenix(self):

        self.__on_phoenix = """
        General setup of bec @ PHOENIX
        important files

        phoenix_bec/scripts/phoenix.py

        phoenix_bec/scripts/phoenix.py

        """
        self.pm(self.__on_phoenix)

    def help_devices(self):
        """

        help text on using devices in bec command line

        """

        self.__on_devices = """

        ===== THE BASICS =========

        All devices are collected in dev.{name}, for example
        dev.falcon          : falcon 4 element detector
        dev.MA_SCANX        : motor ScanX of manipulator MA1
        dev.SAI_MA1         : diode detector etc.

        For safety reasond, after initialization in bec,if possible,
        all devices are DISABLED by default.

        i.e dev.{name}.enabled is set to False for safety
        to enable       :   dev.{name}.enabled = True
        to disable      :   dev.{name}.enabled = False

        To see all devices use

        dev.show_all()

        ===== READING DEVICES IN SCANS ====

        dev.{name}.readout_priority = "monitored"  : reads device in scan on each point
        dev.{name}.readout_priority = "baseline"   : does not read device in scan

        ====== initialize devices =========

        from bec comamnd line      in python script
        %ph_create_base_config     phoenx.create_base_config() -- created main devices
        %add_falcon                phoenix.add_falcon          -- add falcon to existing devices
        ... etc..

        ======  WORK ON EPICS CHANNELS ====

        .get()   : read signal: value only
        .read()  : read signal, into dictionary including timestamp
        .put()   : write signal --- seems to have a callback ????
        .set()   : write signal --- seems to have no callback ??


        OTHER;
        .name    : name of device


        GET INFORMATION ABOUT DEVICES

        ._info      --- seems to be most complete information dictionarty
        .describe() --- = ._info['describe']
                    --- info about Signals/Epics channels (dictionary)
        .describe_configuration
                    --- = ._info['describe_configuration']
                    --- similar to .describe

        .summary         --  lists attributes/names and classes of signals (on screen)

        .info            --

                ._config ._info
        """

        self.pm(self.__on_devices)

    def help_scans(self):
        self.__on_scans = """
        HELP ON SCANS --- missing
        """
        self.pm(self.__on_scans)

    def help_magic(self):
        self.__on_magic = """
        HELP ON MAGIC COMMANDS

        Magic comamnd are called from the iphython shell.
        BL related magic comamnd are defined in post_startup.py

        All magic command start with %, BL related ones use the name convention
        %ph_{name}


        Example:
        PHOENIX [8/225] ❯❯ %ph_create_base_config??
        will initialzes certain         %ph_load_xmap
        %ph_add_xmap

        %ph_restart_bec_server  -- restart the bec server and opens a new terminal with tmux

        """
        self.pm(self.__on_magic)
